diff --git a/src/lib-compression/istream-lzma.c b/src/lib-compression/istream-lzma.c
index faee8a821..d14709156 100644
--- a/src/lib-compression/istream-lzma.c
+++ b/src/lib-compression/istream-lzma.c
@@ -116,10 +116,9 @@ static ssize_t i_stream_lzma_read(struct istream_private *stream)
 				stream->parent->stream_errno;
 		} else {
 			i_assert(stream->parent->eof);
+			lzma_stream_end(zstream);
 			ret = lzma_code(&zstream->strm, LZMA_FINISH);
-			if (ret != LZMA_STREAM_END)
-				if (lzma_handle_error(zstream, ret) == 0)
-					stream->istream.stream_errno = EPIPE;
+			(void)lzma_handle_error(zstream, ret);
 			stream->istream.eof = TRUE;
 		}
 		return -1;
